' Nachbau des AK Modulbus AD210 in Bascom

$regfile = "attiny13.dat"
$crystal = 9600000
$hwstack = 8
$swstack = 8
$framesize = 8
'Baud = 9600

Clkpr = 128
Clkpr = 0
Clkpr = 0


' ungenutzte Digitaleingaenge abschalten
' muss rausgeworfen werden, wenn man den Befehl
'   "Case 32 : Put #1 , Pinb" weiter unten nutzen will 
Didr0 = &B00111011


Config Adc = Single , Prescaler = Auto
Start ADC

Open "comb.1:38400,8,n,1,INVERTED" For Output As #1
Open "comb.2:38400,8,n,1,INVERTED" For Input As #2

' PWM-Frequenz nur 586 Hz; mehr verschlechtert die ADC-Messungen
Config Timer0 = Pwm , Prescale = 64, Compare A Pwm = Clear Up

Ddrb.0 = 1
Ddrb.1 = 1

Dim Ana As Word
Dim Anahi As Byte
Dim Analo As Byte
Dim Command As Byte
Dim N As Byte
Dim Adcnr As Byte


Do

    Get #2 , Command

    Select Case Command

' ADMUX.6:  Ref - 1 VCC 0 1,1V
' ADMUX.5:  ADLAR
' ADMUX.1:  1
' ADMUX.0:  0  ADC2/PB4    1  ADC3/PB3

        Case 1 : Put #1 , 100
       Case 16 : Get #1 , Analo
               Portb = Analo
        Case 17 : Get #1 , Analo
                Ddrb = Analo
        Case 32 : Put #1 , Pinb
        Case 48 : Admux = &B01000010                        ' Ref=1,1V   ADC2
            Gosub Achtbit
        Case 49 : Admux = &B01000011                        ' Ref=1,1V   ADC3
            Gosub Achtbit
        Case 50 : Admux = &B00000010                        ' Ref=VCC   ADC3
            Gosub Achtbit
        Case 51 : Admux = &B00000011                        ' Ref=VCC   ADC3
            Gosub Achtbit
        Case 56 : Admux = &B01000010                        ' Ref=1,1V   ADC2
            Gosub Zehnbit
        Case 57 : Admux = &B01000011                        ' Ref=1,1V   ADC3
            Gosub Zehnbit
        Case 58 : Admux = &B00000010                        ' Ref=VCC   ADC2
            Gosub Zehnbit
        Case 59 : Admux = &B00000011                        ' Ref=VCC   ADC3
            Gosub Zehnbit

        Case 64 : Get #2 , Analo
            Pwm0a = Analo

        Case 100:
            For N = 0 To 61
                Gosub Achtbit
            Next
        Case 101:
            For N = 0 To 31
                Toggle Admux.0
                Gosub Achtbit
            Next

    End Select

Loop

Achtbit:

    If Admux.0 = 0 Then
        Adcnr = 2
    Else
        Adcnr = 3
    End If
    Ana = Getadc(adcnr)
    Shift Ana , Right , 2
    Put #1 , Ana

Return

Zehnbit:

    If Admux.0 = 0 Then
        Adcnr = 2
    Else
        Adcnr = 3
    End If
     Ana = Getadc(adcnr)
    Anahi = High(ana)
    Analo = Low(ana)
    Put #1 , Anahi
    Put #1 , Analo

Return

End
